﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.PluginInfrastructure;

namespace HeuristicLab.Encodings.IntegerVectorEncoding {
  [NonDiscoverableType]
  public class IntegerVectorEqualityComparer : EqualityComparer<IntegerVector> {
    public override bool Equals(IntegerVector x, IntegerVector y) {
      if (x.Length != y.Length) return false;
      return x.SequenceEqual(y);
    }

    public override int GetHashCode(IntegerVector obj) {
      if (obj == null) return 0;
      return GenerateHashString(obj).GetHashCode();
    }

    private string GenerateHashString(IntegerVector p) {
      StringBuilder sb = new StringBuilder();
      for (int i = 0; i < p.Length; i++)
        sb.Append(p[i].ToString() + ";");
      return sb.ToString();
    }
  }
}
